// Demo code for Grove - Temperature Sensor V1.1/1.2
// Loovee @ 2015-8-26

#include <math.h>

// Following two constants belonge to th HCHO sensor:

#define Vc 4.95               
#define R0 34.28              //the number of R0 you detected just now

const int B = 4275;               // B value of the thermistor
const int Rinit = 100000;         // Rinit = 100k
const int pinTempSensor = A0;     // temperature sensor connect to A0

void setup()
{
    Serial.begin(9600);
}

void loop()
{
    int a = analogRead(pinTempSensor);

    float R = 1023.0/a-1.0;
    R = Rinit*R;

    float temperature = 1.0/(log(R/Rinit)/B+1/298.15)-273.15 - 2; // convert to temperature via datasheet

    int sensorValue=analogRead(A1);     // read the signal (voltage value) from the pin A1 (analog)
    double Rs=(1023.0/sensorValue)-1;   // calculate Rs out of the read voltage value of pin A1
    
    Serial.print("Rs = ");
    Serial.println(Rs);                 // Print the real value of Rs
    double ppm=pow(10.0,((log10(Rs/R0)-0.0827)/(-0.4807)));  // calculate the HCHO level withs this callculation (ppm)
    
    Serial.print("HCHO ppm = ");        // Print the VOC value 
    Serial.println(ppm);

    
    Serial.print("temperature (degrees Celsius) = ");
    Serial.println(temperature);

    delay(2000);
}
